//     LM7001   LPT
//   4     -  SDR
//LPT_bit0(pin2)=CL LPT_bit1(pin3)=DARTA LPT_bit2(pin4)=CE
//   LPT   ,  inpout32.dll
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls;
  function Inp32(PortAdr: word): byte; stdcall; external 'inpout32.dll';
  function Out32(PortAdr: word; Data: byte): byte; stdcall; external 'inpout32.dll';

type
  TForm1 = class(TForm)
    TrackBar1: TTrackBar;
    Label2: TLabel; Label1: TLabel; Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label3: TLabel;
    procedure TrackBar1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  step,f,hi,lo,sys,port,data,tmp,i:  integer;
  step1: real;
implementation

{$R *.dfm}

Function st(tmp:byte):byte; //    ( 0-7)tmp,  st - 
    begin
      st:=255;
      if  tmp=0 then st:=1;  if  tmp=1 then st:=2;  if  tmp=2 then st:=4; if  tmp=3 then st:=8;
      if  tmp=4 then st:=16; if  tmp=5 then st:=32; if  tmp=6 then st:=64; if  tmp=7 then st:=128;
    end;

Function i2c_del:byte; //  ,      
  var tc: integer; begin tc:=0; while tc<10000 do begin inc(tc); end; i2c_del:=0; end;

Function lm_byte:boolean; //  DATA   LM7001  LPT 
  begin
    i:=0;
    while i<=7 do
    begin
    if (data and st(i))=st(i) then  //  (i)   data  "1"
      begin
        Out32(Port, $04+$02); i2c_del; Out32(Port, $04+$03);i2c_del; Out32(port,$04+$02); i2c_del;
      end
    else   //  (i)   data  "0"
      begin
        Out32(Port, $04+$00); i2c_del; Out32(Port, $04+$01);i2c_del;Out32(port,$04+$00); i2c_del;
      end;
    inc(i);
    end;
    lm_byte:=true;
  end;


function link:boolean; //  LM7001    HI,LO,SYS
  begin
  data:=$04;  out32(port,data); i2c_del;  //  - "1"   CE
  hi:=round(int(f/25/256)); //hi -     (f)
  lo:=round(int(f/25)-hi*256);  //lo -     (f)
  //  HI_L0(  LM7001 -   16000!
  data:=lo; lm_byte; data:=hi; lm_byte; data:=sys; lm_byte; // HI,LO,SYS  LM7001
  data:=$00;  out32(port,data); i2c_del;  //  - "0"   CE
  link:=true;
  end;



procedure TForm1.TrackBar1Change(Sender: TObject);
begin
f:=Trunc(form1.TrackBar1.Position*4*step1); link; // SDR    4  ,   *4....
Form1.Label1.Caption:=FloatToStr(f)+''; //   VCO
Form1.Label2.Caption:=FloatToStr(f/4); //   RX SDR
Form1.Label5.Caption:='StepVCO='+IntToStr(step)+'';
Form1.Label6.Caption:='StepSDR='+FloatToStr(step1)+'';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
port:=$378; // LPT  LPT1=378H
data:=$00;  out32(port,data);
step:=10; //     LM7001 (1,5,10,25,50,100 )
step1:=step/4;
//  VCO     16000*step
  if  step=1 then sys:=$a0; //     LM7001      ( PDF)
//if  step=5 then sys:=??   // PDF       SYS     
//if step=10 then sys:=??
//if step=25 then sys:=??
//if step=50 then sys:=??
end;

end.

//    ,     
//    LM7001,    .

